this.name      = "behemoth_fighter"; 
this.author    = "eric walch"; 
this.copyright = "� 2008 the Oolite team.";
this.description = "ship script for the behemoth.oxp of aegidean";
this.version   = "1.03";

/*
Escorts added with scanClass CLASS_POLICE always start with a wingman role. However, with scanning for a formationleader they only accept a ship with role police as a mother. When not available, a wingman becomes role police. All next wingmen will now see a ship with role police and will follow him.  By this mechanisme the Behemoth itself looses all its escorts (wingmen). 
Therefor explicit set the role of these behemoth escorts as escort on spawning. spawnedAsEscort() trigers before shipSpawned().
"TARGET_LOST" is removed from its custom AI.
*/
this.spawnedAsEscort = function (mother)
{
    this.ship.switchAI("behemothEscortAI.plist")
    this.ship.primaryRole = "escort"
    this.ship.AIState ="FLYING_ESCORT"
    if (mother.group && mother.group.ships.indexOf(this.ship)<0) mother.group.addShip(this.ship);
}


this.shipLaunchedFromStation = function ()
{
    if (!this.ship.target)
    {
        this.ship.reactToAIMessage("TARGET_LOST");
        // player could be attacking cloaked, then defenders launch without target.
    }
    else
    {
        if (this.ship.target.position.distanceTo(this.ship) > 6000) this.ship.reactToAIMessage("HURRY_UP");
    }
}

this.shipBeingAttacked = function (whom)
{
    {
        if (whom && this.ship.position.distanceTo(whom) > 15000) this.ship.reactToAIMessage("HURRY_UP");
        // this event is even received when attacked out of scanner range. This will send ship
        // in direction of attacker before going in attack mode.
        this.attacker = whom;
    }
}

this.shipLostTarget = this.shipTargetLost = function (whom)  // shipLostTarget() is deprecated since 1.74
{
    if (this.attacker && this.attacker.isShip &&this.ship.AIState !== "FLYING_ESCORT")
    {
        this.ship.target = this.attacker;
        this.ship.reactToAIMessage("HURRY_UP");
    }
}

this.offenceCommittedNearby = function (who)
{
    if (this.ship.target && this.ship.target.scanClass === "CLASS_CARGO" && who.scanClass !== "CLASS_POLICE") 
    {
        this.ship.target = who;
    }
    // targetting cargo only happens with tharglets and not on police ships that accidently fired.
    // and in the heat of the fight a lof of friendly fire takes place.
}